local SML = LibStub("LibSharedMedia-3.0");

DeathClock.unitIDDisplayText = {
	["Target"] = "target",
	["Target of Target"] = "targettarget",
	["Target of Target of Target"] = "targettargettarget",
	["Pet Target"] = "pettarget,",
	["Focus"] = "focus",
	["Mouseover"] = "mouseover",
	["Boss 1"] = "boss1",
	["Boss 2"] = "boss2",
	["Boss 3"] = "boss3",
	["Boss 4"] = "boss4",
	["Arena 1"] = "arena1",
	["Arena 2"] = "arena2",
	["Arena 3"] = "arena3",
	["Arena 4"] = "arena4",
	["Arena 5"] = "arena5",
	["Party 1 Target"] = "party1target",
	["Party 2 Target"] = "party2target",
	["Party 3 Target"] = "party3target",
	["Party 4 Target"] = "party4target",
	["Party 5 Target"] = "party5target",
	["Raid  1 Target"] = "raid1target",
	["Raid  2 Target"] = "raid2target",
	["Raid  3 Target"] = "raid3target",
	["Raid  4 Target"] = "raid4target",
	["Raid  5 Target"] = "raid5target",
	["Raid  6 Target"] = "raid6target",
	["Raid  7 Target"] = "raid7target",
	["Raid  8 Target"] = "raid8target",
	["Raid  9 Target"] = "raid9target",
	["Raid 10 Target"] = "raid10target",
	["Raid 11 Target"] = "raid11target",
	["Raid 12 Target"] = "raid12target",
	["Raid 13 Target"] = "raid13target",
	["Raid 14 Target"] = "raid14target",
	["Raid 15 Target"] = "raid15target",
	["Raid 16 Target"] = "raid16target",
	["Raid 17 Target"] = "raid17target",
	["Raid 18 Target"] = "raid18target",
	["Raid 19 Target"] = "raid19target",
	["Raid 20 Target"] = "raid20target",
	["Raid 21 Target"] = "raid21target",
	["Raid 22 Target"] = "raid22target",
	["Raid 23 Target"] = "raid23target",
	["Raid 24 Target"] = "raid24target",
	["Raid 25 Target"] = "raid25target",
	["Raid 26 Target"] = "raid26target",
	["Raid 27 Target"] = "raid27target",
	["Raid 28 Target"] = "raid28target",
	["Raid 29 Target"] = "raid29target",
	["Raid 30 Target"] = "raid30target",
	["Raid 31 Target"] = "raid31target",
	["Raid 32 Target"] = "raid32target",
	["Raid 33 Target"] = "raid33target",
	["Raid 34 Target"] = "raid34target",
	["Raid 35 Target"] = "raid35target",
	["Raid 36 Target"] = "raid36target",
	["Raid 37 Target"] = "raid37target",
	["Raid 38 Target"] = "raid38target",
	["Raid 39 Target"] = "raid39target",
	["Raid 40 Target"] = "raid40target",
}

function DeathClock:GetAnchorFrame(unitID)
	if unitID == "Target" then
		if _G["XPerl_TargetstatsFramehealthBar"] then
			return "TOPRIGHT","XPerl_TargetstatsFramehealthBar","BOTTOMLEFT",0,0
		elseif _G["SUFUnittarget"] then
			return "TOPRIGHT","SUFUnittarget","LEFT",0,0
		else
			return "TOPRIGHT","TargetFrameHealthBar","BOTTOMLEFT",0,0
		end
	elseif unitID == "Focus" then
		if _G["XPerl_FocusstatsFramehealthBar"] then
			return "TOPRIGHT","XPerl_FocusstatsFramehealthBar","BOTTOMLEFT",0,0
		elseif _G["SUFUnitfocus"] then
			return "TOPRIGHT","SUFUnitfocus","LEFT",0,0
		else
			return "TOPRIGHT","FocusFrameHealthBar","BOTTOMLEFT",0,0
		end
	elseif unitID == "Boss 1" then
		if _G["SUFHeaderbossUnitButton1"] then
			return "TOPRIGHT","SUFHeaderbossUnitButton1","LEFT",0,0
		else
			return "TOPRIGHT","Boss1TargetFrameHealthBar","BOTTOMLEFT",0,0
		end
	elseif unitID == "Boss 2" then
		if _G["SUFHeaderbossUnitButton2"] then
			return "TOPRIGHT","SUFHeaderbossUnitButton2","LEFT",0,0
		else
			return "TOPRIGHT","Boss2TargetFrameHealthBar","BOTTOMLEFT",0,0
		end
	elseif unitID == "Boss 3" then
		if _G["SUFHeaderbossUnitButton3"] then
			return "TOPRIGHT","SUFHeaderbossUnitButton3","LEFT",0,0
		else
			return "TOPRIGHT","Boss3TargetFrameHealthBar","BOTTOMLEFT",0,0
		end
	elseif unitID == "Boss 4" then
		if _G["SUFHeaderbossUnitButton4"] then
			return "TOPRIGHT","SUFHeaderbossUnitButton4","LEFT",0,0
		else
			return "TOPRIGHT","Boss4TargetFrameHealthBar","BOTTOMLEFT",0,0
		end
	else
		return "CENTER","UIParent","CENTER",0,0
	end
end

function DeathClock:ApplyFrameSettings(frame)
	local settings = self.db.profile.clocks[frame.unitText]
	if settings.anchorFrame and not _G[settings.anchorFrame] then
		settings.p1, settings.anchorFrame, settings.p2, settings.x, settings.y = DeathClock:GetAnchorFrame(unitID)
	end
	if settings.anchorFrame and _G[settings.anchorFrame] then
		frame:SetParent(_G[settings.anchorFrame])
		frame:SetScale(1/_G[settings.anchorFrame]:GetEffectiveScale())
	else
		frame:SetParent(nil)
		frame:SetScale(1)
	end
	frame:ClearAllPoints()
	frame:SetPoint(settings.p1,settings.anchorFrame,settings.p2,settings.x,settings.y)
	frame.text:SetFont(SML:Fetch('font', settings.font), settings.size, settings.outline)
	frame.text:SetTextColor(settings.foreground.r, settings.foreground.g, settings.foreground.b, settings.foreground.a)
	local oldText = frame.text:GetText()
	frame.text:SetText("00M00M")
	local textWidth = frame.text:GetStringWidth()
	frame.text:SetText(oldText)
	frame:SetWidth(textWidth+2)
	frame:SetHeight(settings.size + 2)
	frame.texture:SetTexture(settings.background.r, settings.background.g, settings.background.b, settings.background.a)
	
	if not settings.show then
		frame:Hide()
	end
end



local function ShowToolTip(frame)
	if not DeathClock.db.profile.clocks[frame.unitText].lock then
		GameTooltip:SetOwner(frame, "ANCHOR_NONE");
		local x, y = GetCursorPosition();
		local scale = GameTooltip:GetEffectiveScale();
		GameTooltip:ClearAllPoints();
		GameTooltip:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", (x/scale + 20), (y/scale - 20));
		GameTooltip:SetText( "|cff00ccffDeath Clock (|r|cffffffff" .. frame.unitText .. "|r|cff00ccff) Unlocked|r\n   |cffffffffDrag|r to reposition\n   |cffffffffRight click|r to lock"  )
		if frame.isDragging then
			GameTooltip:Hide()
		else
			GameTooltip:Show()
		end
	end
end


local function HideToolTip(frame)
	GameTooltip:Hide()
end


local function AnchorFailed(frame)
	local settings = DeathClock.db.profile.clocks[frame.unitText]
	settings.p1, settings.anchorFrame, settings.p2, settings.x, settings.y = "CENTER","UIParent","CENTER",0,0
	DeathClock.db.profile.clocks[frame.unitText].lock = false
	frame.anchorSecure = 2
	print("|cff00ccffThe Death Clock for '|r|cffffffff"..frame.unitText.."|r|cff00ccff' can not find the right frame to attach to. The Death Clock is now unlocked and centered on your screen ready to be dragged into position.\n\n Right click the Death Clock to lock it when positioned.|r")
	DeathClock:ApplySettings(frame)
end

function DeathClock:SetupFrame(unitText)
	local unitID = self.unitIDDisplayText[unitText]
	local frame = CreateFrame("Button", "DeathClock-"..unitID)
	frame.unit = unitID
	frame.unitText = unitText
	frame:SetFrameStrata("HIGH")
	frame.texture = frame:CreateTexture("bg", "BACKGROUND", "ActionBarButtonTemplate")
	frame.texture:SetAllPoints(frame)
	frame.texture:SetTexture(0,0,0,.8)
	frame.text = frame:CreateFontString("DeathClock-"..unitID.."-Text", "OVERLAY")
	frame.text:SetAllPoints(frame)
	frame.text:SetFontObject(TextStatusBarText)
	frame.text:SetJustifyH("RIGHT")
	frame:SetClampedToScreen(true)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForClicks("RightButtonUp")
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", 
		function(frame) 
			if not DeathClock.db.profile.clocks[frame.unitText].lock then
				frame:StartMoving() 
				frame.isDragging = true
				HideToolTip(frame)
			end
		end
	)
	frame:SetScript("OnDragStop", 
		function(frame) 
			frame:StopMovingOrSizing() 
			local settings = DeathClock.db.profile.clocks[frame.unitText]
			local p1,_,p2,x,y = frame:GetPoint()
			settings.x = x
			settings.y = y
			settings.anchorFrame = "UIParent"
			settings.p1 = p1
			settings.p2 = p2
			frame.isDragging = false
			ShowToolTip(frame)
		end
	)
	frame:SetScript("OnClick",
		function(frame)
			local settings = self.db.profile.clocks[frame.unitText]

			if settings.lock then
				DeathClock:DoAnnounce(UnitGUID(frame.unit))
			else
				settings.lock = true
				DeathClock:ApplySettings()
			end
		end
	)
	frame:SetScript("OnEnter", ShowToolTip)
	frame:SetScript("OnLeave", HideToolTip)
	
	self.frames[unitText] = frame
	self:ApplyFrameSettings(frame)
	return frame
end

function DeathClock:RestoreFrameDefaults(unit)
	self.db.profile.clocks[unit] = self:GetTableDefaults(unit)
	if self.frames[unit] then
		self.frames[unit].anchorSecure = nil
	end
end


function DeathClock:GetTableDefaults(unitID)
	local defaults = {
		background = {r = 0,b = 0,g = 0, a = .25},
		foreground = {r = 1,b = 1,g = 1, a = 1},
		font = "DorisPP",
		size = 6,
		outline = 'OUTLINE',
		height = 16,
		width = 51,
		lock = true,
	}
	defaults.show = unitID == "Target" or unitID == "Focus" or unitID == "Boss 1" or unitID == "Boss 2" or unitID == "Boss 3" or unitID == "Boss 4"
	defaults.p1, defaults.anchorFrame, defaults.p2, defaults.x, defaults.y = DeathClock:GetAnchorFrame(unitID)
	return defaults
end

function DeathClock:UpdateClockFrames()
	for unitText, clockSettings in pairs(self.db.profile.clocks) do 
		local unitID = self.unitIDDisplayText[unitText]

		local frame = self.frames[unitText] or self:SetupFrame(unitText)
		if clockSettings.show and (UnitExists(unitID) or not clockSettings.lock) then
			if UnitExists(unitID) then
				frame.text:SetText(self.units[UnitGUID(unitID)].text)
			else
				frame.text:SetText("Unlocked")
			end
			if frame.anchorSecure ~= 2 then
				if clockSettings.anchorFrame and not _G[clockSettings.anchorFrame]:IsVisible() then
					if not frame.anchorSecure then
						frame.anchorSecure = 1
					else
						AnchorFailed(frame)
					end
				else
					frame.anchorSecure = 2
				end
			end
			frame:Show()
		elseif frame then
			frame:Hide()
		end
	end
end